//+------------------------------------------------------------------+
//|                                        ExFit Color_v2.1 600+.mq4 |
//|                                Copyright  2014, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers   3
#property indicator_color1    OrangeRed
#property indicator_width1    2
#property indicator_color2    DeepSkyBlue
#property indicator_width2    2
#property indicator_color3    DeepSkyBlue
#property indicator_width3    2


extern int     Price             =   0;      //Price Mode (0...6) 
extern int     Length            =  25;      //Period of Smoothing
extern int     Order             =   2;      //Fitting Order
extern double  WeightFactor      =   2;      //WeightFactor(eg. 2-EMA,1-Wilder) 
extern int     Window            = 500;      //Window size in bars
extern string  alerts            = "--- Alerts & Emails ---";
extern int     AlertMode         =   1;      //Alert Mode (0-off,1-on)
extern int     SoundsNumber      =   5;      //Number of sounds after Signal
extern int     SoundsPause       =   5;      //Pause in sec between sounds 
extern string  UpSound           = "alert.wav";
extern string  DnSound           = "alert.wav";
extern int     EmailMode         =   0;      //0-on,1-off   
extern int     EmailsNumber      =   1;      //0-on,1-off
extern int     WarningMode       =   0;      //Warning Mode (0-off,1-on)

double exfit[];
double uptrend1[];
double uptrend2[];
double trend[];

double   prevtrend;
datetime prevtime, preTime, ptime;
string   IndicatorName, TF, prevmess, prevemail;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
{
   IndicatorDigits(Digits);
   
   IndicatorBuffers(4);
   SetIndexBuffer(0,   exfit); SetIndexStyle(0,DRAW_LINE); 
   SetIndexBuffer(1,uptrend1); SetIndexStyle(1,DRAW_LINE); 
   SetIndexBuffer(2,uptrend2); SetIndexStyle(2,DRAW_LINE); 
   SetIndexBuffer(3,   trend);
     
   IndicatorName = WindowExpertName(); 
   IndicatorShortName(IndicatorName+"("+Price+","+Length+","+Order+")");
   
      
   SetIndexLabel(0,"ExFit"  );
   SetIndexLabel(1,"UpTrend");
   SetIndexLabel(2,"UpTrend");
     
   return (0);
}
//+------------------------------------------------------------------+
//| ExFit Color_v2.1 600+                                            |
//+------------------------------------------------------------------+
int start() 
{
   int shift, counted_bars = IndicatorCounted();
      
   if(counted_bars < 0) return(0);
  	if(counted_bars < 1)  
      for(int i=0;i<Bars-1;i++) 
      {
      exfit[i]    = EMPTY_VALUE;
      uptrend1[i] = EMPTY_VALUE; 
      uptrend2[i] = EMPTY_VALUE;
      }
   
   
   xfit(Price,Length,Order,WeightFactor,Window,counted_bars,exfit);
   
   
   for(shift=Window-1;shift>=0;shift--)
   {
   uptrend1[shift] = EMPTY_VALUE; 
   uptrend2[shift] = EMPTY_VALUE;
                 
   trend[shift] = trend[shift+1];
   if(exfit[shift] > exfit[shift+1]) trend[shift] = 1;
   if(exfit[shift] < exfit[shift+1]) trend[shift] =-1;    
         
      if(trend[shift] > 0)
      {
         if(uptrend1[shift+1] == EMPTY_VALUE)
         {
            if(uptrend1[shift+2] == EMPTY_VALUE) 
            {
            uptrend1[shift]   = exfit[shift];
            uptrend1[shift+1] = exfit[shift+1];
            uptrend2[shift]   = EMPTY_VALUE;
            }
            else 
            {
            uptrend2[shift]   = exfit[shift];
            uptrend2[shift+1] = exfit[shift+1];
            uptrend1[shift]   = EMPTY_VALUE;
            }
         }
         else
         {
         uptrend1[shift]  = exfit[shift];
         uptrend2[shift]  = EMPTY_VALUE;
         }
      }
   }   
//----------   
   if(AlertMode > 0)
   {
   bool uptrend = trend[1] > 0 && prevtrend <= 0;                  
   bool dntrend = trend[1] < 0 && prevtrend >= 0;
        
      if(uptrend || dntrend)
      {
         if(isNewBar(Period()))
         {
         BoxAlert(uptrend," : BUY Signal at " +DoubleToStr(Close[1],Digits));   
         BoxAlert(dntrend," : SELL Signal at "+DoubleToStr(Close[1],Digits)); 
         }
      
      WarningSound(uptrend,SoundsNumber,SoundsPause,UpSound,Time[1]);
      WarningSound(dntrend,SoundsNumber,SoundsPause,DnSound,Time[1]);
         
         if(EmailMode > 0)
         {
         EmailAlert(uptrend,"BUY" ," : BUY Signal at " +DoubleToStr(Close[1],Digits),EmailsNumber); 
         EmailAlert(dntrend,"SELL"," : SELL Signal at "+DoubleToStr(Close[1],Digits),EmailsNumber); 
         }
      }
   
      if(prevtime != Time[1]) 
      {
      prevtrend = trend[1];
      prevtime  = Time[1];
      }
   }     
   return (0);
}
   



//------
double value[];    
   
void xfit(int price,int length,int order,double wf,int cntbars,int indcnt,double& xfit[])
{     
double iprice, value1, value2, alpha = wf/(length*0.5 + 1);    
   
   if(indcnt == 0) ArrayResize(value,cntbars); 
   
   for(int k=0;k<order;k++) 
   {
      for(int i=0;i<cntbars;i++) 
      {
      if(k == 0) iprice = iMA(NULL,0,1,0,0,price,i); else iprice = xfit[i];
      if(i == 0) value1 = iprice;
         
      value[i] = alpha*iprice + (1 - alpha)*value1; 
      value1   = value[i];
      }
   
      for(i=cntbars-1;i>=0;i--) 
      {
      if(i == cntbars - 1) xfit[i] = value[i]; else xfit[i] = alpha*value[i] + (1 - alpha)*value2;
              
      value2 = xfit[i];
      }
   }
}

  bool isNewBar(int tf)
{
   static datetime pTime;
   bool res = false;
   
   if(tf >= 0)
   {
      if (iTime(NULL,tf,0) != pTime)
      {
      res   = true;
      pTime = iTime(NULL,tf,0);
      }   
   }
   else res = true;
   
   return(res);
}

bool BoxAlert(bool cond,string text)   
{      
   string mess = IndicatorName + "("+Symbol()+","+TF + ")" + text;
   
   if (cond && mess != prevmess)
	{
	Alert(mess);
	prevmess = mess; 
	return(true);
	} 
  
   return(false);  
}

bool Pause(int sec)
{
   if(TimeCurrent() >= preTime + sec) {preTime = TimeCurrent(); return(true);}
   
   return(false);
}

void WarningSound(bool cond,int num,int sec,string sound,datetime ctime)
{
   static int i;
   
   if(cond)
   {
   if(ctime != ptime) i = 0; 
   if(i < num && Pause(sec)) {PlaySound(sound); ptime = ctime; i++;}       	
   }
}

bool EmailAlert(bool cond,string text1,string text2,int num)   
{      
   string subj = "New " + text1 +" Signal from " + IndicatorName + "!!!";    
   string mess = IndicatorName + "("+Symbol()+","+TF + ")" + text2;
   
   if (cond && mess != prevemail)
	{
	if(subj != "" && mess != "") for(int i=0;i<num;i++) SendMail(subj, mess);  
	prevemail = mess; 
	return(true);
	} 
  
   return(false);  
}	         
 
string tf(int timeframe)
{
   switch(timeframe)
   {
   case PERIOD_M1:   return("M1");
   case PERIOD_M5:   return("M5");
   case PERIOD_M15:  return("M15");
   case PERIOD_M30:  return("M30");
   case PERIOD_H1:   return("H1");
   case PERIOD_H4:   return("H4");
   case PERIOD_D1:   return("D1");
   case PERIOD_W1:   return("W1");
   case PERIOD_MN1:  return("MN1");
   default:          return("Unknown timeframe");
   }
}                   
   